/*
 * spi.c
 *
 *  Created on: Jul 25, 2023
 *      Author: Leexy
 */
#include "debug.h"
#include "string.h"
#include "spi.h"

/* SPI Mode Definition */
#define HOST_MODE     0
#define SLAVE_MODE    1

/* SPI Communication Mode Selection */
#define SPI_MODE   HOST_MODE
//#define SPI_MODE      SLAVE_MODE

/* Global define */
#define Size          18                //SPIݸΪ18

/* Global Variable */

u16 TxData[Size] = {0x0101, 0x0202, 0x0303, 0x0404, 0x0505, 0x0606,
                    0x1111, 0x1212, 0x1313, 0x1414, 0x1515, 0x1616,
                    0x2121, 0x2222, 0x2323, 0x2424, 0x2525, 0x2626};
u16 RxData[Size];

/*********************************************************************
 * @fn      SPI_FullDuplex_Init
 *
 * @brief   Configuring the SPI for full-duplex communication.
 *
 * @return  none
 */
void SPI_FullDuplex_Init(void)
{

    GPIO_InitTypeDef GPIO_InitStructure = {0};      //GPIO鲢ֵ0
    SPI_InitTypeDef  SPI_InitStructure = {0};       //SPI鲢ֵ0

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1, ENABLE);     //APB2ʱ

#if(SPI_MODE == HOST_MODE)                          //SPIPinʽԼӦPinŵĳʼ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init( GPIOA, &GPIO_InitStructure );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;       //Pin5ΪSPI_CLK
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;     //SPIΪHOSTģʽʱCLKΪ츴
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;       //Pin6ΪSPI_MISO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;   //SPI_MISOΪߴ
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;       //Pin7ΪSPI_MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;         //Ϊ츴
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

#elif(SPI_MODE == SLAVE_MODE)
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

#endif

    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;      //SPIͨʽΪ˫ȫ˫

#if(SPI_MODE == HOST_MODE)
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                           //SPIΪMaster

#elif(SPI_MODE == SLAVE_MODE)
    SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;

#endif

    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;                      //ÿݴСΪ8bit
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;                              //ʱݴʱָλ
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;                            //ӵһؿʼ
    SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;                               //ΪӲƬѡ
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;     //ò
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_LSB;                      //Ϊȷ͵λ
    SPI_InitStructure.SPI_CRCPolynomial = 7;                                //SPI_CRCУΪCRC_8
    SPI_Init(SPI1, &SPI_InitStructure);
    SPI_SSOutputCmd(SPI1, ENABLE);                                          //SSOE
    //SPI_NSSInternalSoftwareConfig(SPI1,SPI_NSSInternalSoft_Set);
    SPI_Cmd(SPI1, ENABLE);                                                  //SPI1
    printf("*p=%X\r\n",*(int16_t*)SPI1_BASE);
}

void SENDDATA_TEST(void)
{
    u8 i = 0;
       u8 j = 0;
       u8 value;

       //SystemCoreClockUpdate();
       //Delay_Init();
       //USART_Printf_Init(460800);
       //printf("SystemClk:%d\r\n", SystemCoreClock);
       //printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
   #if(SPI_MODE == SLAVE_MODE)
       printf("Slave Mode\r\n");
       Delay_Ms(1000);

   #endif

       SPI_FullDuplex_Init();

   #if(SPI_MODE == HOST_MODE)
       printf("Host Mode\r\n");
       Delay_Ms(2000);

   #endif
       if(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) != RESET)  //Ƿӷͻ͵λĴ1Ϊѵ0Ϊδ
          {
             SPI_I2S_SendData(SPI1, TxData[i]);
                          }
/*
       while(1)
       {
           while((i < 18) || (j < 18))
           {
               if(i < 18)
               {
                   if(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) != RESET)  //Ƿӷͻ͵λĴ1Ϊѵ0Ϊδ
                   {
                       SPI_I2S_SendData(SPI1, TxData[i]);
                       i++;
                   }
               }

               if(j < 18)
               {
                   if(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) != RESET) //ǷλĴз͵ջ
                   {
                       RxData[j] = SPI_I2S_ReceiveData(SPI1);
                       j++;
                   }
               }
           }

           value = memcmp(TxData, RxData, Size);                               //memcmpڱȽڴֽ

           if(value == 0)
           {
               printf("Same\r\n");
           }
           else
           {
               printf("Different\r\n");
           }

           while(1)
               ;
       }*/

}

